/* gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1999, 2000, 2001, 2002 Free Software Foundation,
Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA 02110-1301, USA. */

#define BITS_PER_MP_LIMB 32
#define BYTES_PER_MP_LIMB 4

/* Generated by tuneup.c, 2009-06-03, gcc 4.3 */

#define MUL_KARATSUBA_THRESHOLD          15
#define MUL_TOOM3_THRESHOLD             106
#define MUL_TOOM4_THRESHOLD             126
#define MUL_TOOM7_THRESHOLD             187

#define SQR_BASECASE_THRESHOLD            9
#define SQR_KARATSUBA_THRESHOLD          51
#define SQR_TOOM3_THRESHOLD             177
#define SQR_TOOM4_THRESHOLD             178
#define SQR_TOOM7_THRESHOLD             345

#define MULLOW_BASECASE_THRESHOLD         0  /* always */
#define MULLOW_DC_THRESHOLD             106
#define MULLOW_MUL_N_THRESHOLD          286

#define DIV_SB_PREINV_THRESHOLD           6
#define DIV_DC_THRESHOLD                 90
#define POWM_THRESHOLD                   89

#define GCD_ACCEL_THRESHOLD              13

#define JACOBI_BASE_METHOD                2

#define DIVREM_1_NORM_THRESHOLD           5
#define DIVREM_1_UNNORM_THRESHOLD     MP_SIZE_T_MAX  /* never */
#define MOD_1_NORM_THRESHOLD              3
#define MOD_1_UNNORM_THRESHOLD            5
#define USE_PREINV_DIVREM_1               1
#define USE_PREINV_MOD_1                  1
#define DIVREM_2_THRESHOLD                0  /* always */
#define DIVEXACT_1_THRESHOLD              0  /* always */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always */

#define GET_STR_DC_THRESHOLD             12
#define GET_STR_PRECOMPUTE_THRESHOLD     14
#define SET_STR_THRESHOLD              1694

#define MUL_FFT_TABLE  { 272, 736, 896, 2560, 10240, 24576, 98304, 917504, 0 }
#define MUL_FFT_MODF_THRESHOLD          152
#define MUL_FFT_THRESHOLD              1088

#define SQR_FFT_TABLE  { 208, 672, 896, 2560, 10240, 24576, 98304, 393216, 0 }
#define SQR_FFT_MODF_THRESHOLD          184
#define SQR_FFT_THRESHOLD               960

/* Tuneup completed successfully, took 327 seconds */

